program marriage(input,output);

const n=8;

var m: integer; w: integer; r: integer;
    wmr: array [1..n, 1..n] of integer;
    mwr: array [1..n, 1..n] of integer;
    rmw: array [1..n, 1..n] of integer;
    rwm: array [1..n, 1..n] of integer;
    x: array [1..n] of integer;
    y: array [1..n] of integer;
    single: array [1..n] of boolean;

procedure print;
  var m: integer; rm, rw: integer;
begin
  rm:=0;
  rw:=0;
  for m:=1 to n do
  begin
    write(x[m]:4);
    rm:=rm+rmw[m,x[m]];
    rw:=rw+rwm[x[m],m]
  end;
  writeln(rm:8,rw:4)
end;

procedure try(m: integer);
  var r: integer; w: integer;

  function stable: boolean;
    var pm: integer; pw: integer;
        i,lim: integer; s: boolean;

  begin
    s:=true;
    i:=1;
    while (i<r) and s do
    begin
      pw:=wmr[m,i];
      i:=i+1;
      if not single[pw] then
        s:=rwm[pw,m]>rwm[pw,y[pw]]
    end;
    i:=1;
    lim:=rwm[w,m];
    while (i<lim) and s do
    begin
      pm:=mwr[w,i];
      i:=i+1;
      if pm<m then
        s:=rmw[pm,w]>rmw[pm,x[pm]]
    end;
    stable:=s
  end;

begin
  for r:=1 to n do
  begin
    w:=wmr[m,r];
    if single[w] then
      if stable then
      begin
        x[m]:=w;
        y[w]:=m;
        single[w]:=false;
        if m<n then
          try(m+1)
        else
          print;
        single[w]:=true
      end
  end
end;

begin
  for m:=1 to n do
    for r:=1 to n do
    begin
      read(wmr[m,r]);
      rmw[m,wmr[m,r]]:=r
    end;
  for w:=1 to n do
    for r:=1 to n do
    begin
      read(mwr[w,r]);
      rwm[w,mwr[w,r]]:=r
    end;
  for w:=1 to n do single[w]:=true;
  try(1)
end.

7 2 6 5 1 3 8 4
4 3 2 6 8 1 7 5
3 2 4 1 8 5 7 6
3 8 4 2 5 6 7 1
8 3 4 5 6 1 7 2
8 7 5 2 4 3 1 6
2 4 6 3 1 7 5 8
6 1 4 2 7 5 3 8

4 6 2 5 8 1 3 7
8 5 3 1 6 7 4 2
6 8 1 2 3 4 7 5
3 2 4 7 6 8 5 1
6 3 1 4 5 7 2 8
2 1 3 8 7 4 6 5
3 5 7 2 4 1 8 6
7 2 8 4 5 6 3 1

